import os, sys, struct, zlib

def read_int32(fp):
    v, = struct.unpack('>i', fp.read(4))
    return v

def extract(arg):
    try:
        fp = file(arg, 'rb')
    except IOError:
        return

    mark = fp.read(4)
    if (mark != "MARK"):
        print "Not a MARK file"
        return -1
    
    fp.seek(4, os.SEEK_CUR)
    count = read_int32(fp)
    data_offset = read_int32(fp)

    files = []
    
    fp.seek(0x9c98, os.SEEK_SET)
    for i in xrange(count):
        fp.seek(4, os.SEEK_CUR)
        length = read_int32(fp)
        offset = data_offset
        fp.seek(20, os.SEEK_CUR)
        name = ""
        c = fp.read(1)
        while (c != '\0'):
            name += c
            c = fp.read(1)
    
        files.append((name, length, offset))
        data_offset += length

    for (name, length, offset) in files:
        if name.startswith('game:\\Data'):
            filename = "XBLA" + name[10:].replace('\\', '/')
            dir = os.path.dirname(filename)
            if not os.path.isdir(dir):
                os.makedirs(dir)

            fp.seek(offset, os.SEEK_SET)
            base, extension = os.path.splitext(filename)
            if (extension == '.png'):
                file(filename, 'wb').write(fp.read(length))
            elif (extension == '.cmt'):
                file(base + ".dds", 'wb').write(zlib.decompress(fp.read(length)[4:]))
                
def main(args):
    for i in xrange(1,32):
        extract(str(i) + 'hd.mark')
    
if __name__=='__main__':
    sys.exit(main(sys.argv[1:]))
